From 316a22855c6977a2676e377c7f572e0d1bd1e0fb Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Feb 09 2017 15:58:11 +0000
Subject: [PATCH 741/1001] More explicit widget validation errors


---

diff --git a/hubs/tests/test_widget_base.py b/hubs/tests/test_widget_base.py
index bc8a166..0abe27c 100644
--- a/hubs/tests/test_widget_base.py
+++ b/hubs/tests/test_widget_base.py
@@ -45,13 +45,13 @@ class WidgetTest(APPTest):
             AttributeError, '.* "name" .*', test_widget.validate)
         test_widget.name = "invalid name \xe2\x98\xba"
         self.assertRaisesRegexp(
-            AttributeError, '^Invalid widget name: ', test_widget.validate)
+            AttributeError, '^invalid widget name: ', test_widget.validate)
         test_widget.name = "localtest"
         self.assertRaisesRegexp(
-            AttributeError, '.* "position" .*', test_widget.validate)
+            AttributeError, '"position" .*', test_widget.validate)
         test_widget.position = "invalid"
         self.assertRaisesRegexp(
-            AttributeError, '.* "position" .*', test_widget.validate)
+            AttributeError, '"position" .*', test_widget.validate)
         test_widget.position = "both"
         self.assertRaisesRegexp(
             AttributeError, '.* "root" .*', test_widget.validate)
diff --git a/hubs/widgets/base.py b/hubs/widgets/base.py
index 50b726e..c6b87af 100644
--- a/hubs/widgets/base.py
+++ b/hubs/widgets/base.py
@@ -71,23 +71,23 @@ class Widget(object):
         Raises: AttributeError
         """
         if self.name is None:
-            raise AttributeError('Widgets must have a "name" attribute')
+            raise AttributeError('widgets must have a "name" attribute')
         if not re.match('^[\w_.-]+$', self.name):
             raise AttributeError(
-                'Invalid widget name: %r. ' % self.name +
+                'invalid widget name: %r. ' % self.name +
                 'Please use URL-compatible characters.')
         if self.position not in ['left', 'right', 'both']:
             raise AttributeError(
-                '%r\'s "position" is not: `left`, `right` or `both`'
-                % self.name)
+                '"position" attribute is not: `left`, `right` or `both`'
+                )
         root_view = self.get_views().get("root")
         if root_view is None:
             raise AttributeError(
-                'Widgets must have a "root" view, please refer to the '
+                'widgets must have a "root" view, please refer to the '
                 'documentation.')
         if "/" not in root_view.url_rules:
             raise AttributeError(
-                'The root view must be registered for the "/" URL rule.')
+                'the root view must be registered for the "/" URL rule.')
 
     def get_parameters(self):
         """
diff --git a/hubs/widgets/registry.py b/hubs/widgets/registry.py
index 109e69a..ad4d494 100644
--- a/hubs/widgets/registry.py
+++ b/hubs/widgets/registry.py
@@ -52,7 +52,11 @@ class WidgetRegistry(UserDict):
                 widget.name = widget_path[len(prefix):]
             else:
                 widget.name = widget_path
-        widget.validate()
+        try:
+            widget.validate()
+        except AttributeError as e:
+            raise AttributeError(
+                "Error registering %s: %s" % (widget_path, e))
         self.data[widget.name] = widget
 
     def register_routes(self, app):

